package de.steev.Tridentwar.States;

import de.steev.Tridentwar.manager.GameManager;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;
import org.bukkit.scoreboard.DisplaySlot;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Scoreboard;
import org.bukkit.scoreboard.ScoreboardManager;

public class Active {
    private final GameManager gameManager;
    private final ScoreboardManager manager;
    private boolean isInitialized = false;

    public Active(GameManager gameManager) {
        this.manager = Bukkit.getScoreboardManager();
        this.gameManager = gameManager;
    }

    public void run(){
        this.gameManager.isWaiting = false;
        this.gameManager.getPlayerManager().setGameModes(GameMode.SURVIVAL);
        this.gameManager.getPlayerManager().setPlayersHealth(20F);
        this.gameManager.getPlayerManager().setAlive(Bukkit.getOnlinePlayers().size());
        this.gameManager.getPlayerManager().giveKits();

        Scoreboard board = manager.getNewScoreboard();
        Objective obj = board.registerNewObjective("Tridentwar", "dummy", "SLPNetwork");
        obj.setDisplaySlot(DisplaySlot.SIDEBAR);

        for (Player p : Bukkit.getOnlinePlayers()) {

            if (!isInitialized) {
                this.gameManager.getPlayerManager().setKills(p, 0);
            }

            obj.getScore("=-=-=-=-=-=-=-=-=-=-=").setScore(5);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.player") + " " + p.getDisplayName()).setScore(4);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.alive") + " " + this.gameManager.getPlayerManager().getAlive()).setScore(3);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.kills") + " " + this.gameManager.getPlayerManager().getKills(p)).setScore(2);
            obj.getScore("").setScore(1);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.server")).setScore(0);

            p.setScoreboard(board);

        }
    }
}
