package de.steev.Tridentwar.tasks;

import de.steev.Tridentwar.manager.GameManager;
import de.steev.Tridentwar.manager.GameState;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scoreboard.DisplaySlot;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.Scoreboard;
import org.bukkit.scoreboard.ScoreboardManager;

public class LobbyWaitingTask extends BukkitRunnable {
    private GameManager gameManager;
    private final ScoreboardManager manager;

    public LobbyWaitingTask(GameManager gameManager) {
        this.gameManager = gameManager;
        this.manager = Bukkit.getScoreboardManager();
        System.out.println("DEBUG: Lobby is Waiting");
    }

    private int timeLeft = 30;

    @Override
    public void run() {

        if (Bukkit.getOnlinePlayers().size() >= this.gameManager.getPlugin().config.getInt("maxplayers")) {
            timeLeft=10;
        }

        Scoreboard board = manager.getNewScoreboard();

        Objective obj = board.registerNewObjective("Tridentwar", "dummy", "SLPNetwork");
        obj.setDisplaySlot(DisplaySlot.SIDEBAR);


        timeLeft--;

        for (Player player : Bukkit.getOnlinePlayers()){

            obj.getScore("=-=-=-=-=-=-=-=-=-=-=").setScore(4);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.lobby.player") + " " + player.getDisplayName()).setScore(3);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.lobby.timeleft") + " " + timeLeft).setScore(2);
            obj.getScore("").setScore(1);
            obj.getScore(this.gameManager.getPlugin().config.getString("scoreboard.ingame.server")).setScore(0);

            player.setScoreboard(board);
        }

        this.gameManager.getMessageManager().broadCastXPBar(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft));
        if (timeLeft > 10) {
            switch (timeLeft) {
                case 30: Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft)); break;
                case 25: Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft)); break;
                case 20: Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft)); break;
                case 15: Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft)); break;
            }
        } else if(timeLeft <= 10) {
            Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&', this.gameManager.getPlugin().languageDataConfig.getString("game.countdown") + timeLeft));

            /**
             * Checks if the time has run out and messages the Players about game beeing aborted
             * proceeds then to abort the game and change gamestate accordingly
             */
            if(timeLeft <= 0) {
                if(Bukkit.getOnlinePlayers().size() < this.gameManager.getPlugin().config.getInt("minplayers")) {
                    Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&',
                            this.gameManager.getFileHandler().replaceVars(this.gameManager.getPlugin().languageDataConfig.getString("error.not-enough-players"), null, null)));
                    this.gameManager.setGameState(GameState.ABORTING);
                } else {
                    Bukkit.broadcastMessage(ChatColor.translateAlternateColorCodes('&',
                            this.gameManager.getFileHandler().replaceVars(this.gameManager.getPlugin().languageDataConfig.getString("game.starting"), null, null)));
                    this.gameManager.setGameState(GameState.ACTIVE);
                }
                cancel();
                return;
            }
        }
    }

    /**
     * calls cancel to stop task
     */
    public void stopTask() {
        cancel();
    }
}
